Subject: Re: bug#55655: 28.1; package.el no longers respects `user-emacs-directory'

From: Eli Zaretskii <[email-masked]>
Date: Thu, 26 May 2022 16:55:23 +0300

> From: Shitikanth <[email-masked]>
> Date: Thu, 26 May 2022 18:49:53 +0530
> Cc: [email-masked]
> 
> I think almost all emacs packages follow the convention of setting
> the location of their cache/configuration files by
> calling`locate-user-emacs-file'.
> This enables the user to just set the user-emacs-directory instead of
> configuring all of them individually. (This works great for the use case of
> wanting to put your emacs config in a location other than ~/.emacs.d or
> even having multiple emacs configs.)
> 
> > (defcustom package-user-dir (locate-user-emacs-file "elpa")
> 
> Looking at the definition of `package-user-dir`, it ostensibly tries to
> follow the same convention as well. It has just stopped working for
> some reason since 9973019764, which is why I consider this a bug.
> 
> Is it actually intended behavior that `package-user-dir' should not
> by default have the same value as (locate-user-emacs-file "elpa")?

Yes, but user-emacs-directory isn't supposed to be set, it is supposed
to be computed by Emacs early at startup, and then used for the rest
of the startup processing.

Stefan, am I missing something here?